package teen

import (
	"fmt"
	"server/game/room"
	"server/msg"
)

// 看牌
func lookCard(room *room.Room, sitPos int) {
	SendRoundMsgToAll(room, &msg.ReqRound{
		Round:       int32(room.Round),
		RoundSitPos: int32(sitPos),
		PlayerOpt:   &msg.PlayerOpt{OptType: msg.PlayerOptType_OPT_LOOK_CARD},
		UserId:      room.GetPlayerBySitPos(sitPos).GetUserId(),
	})
}

// 弃牌
func discardCard(room *room.Room, sitPos int) {
	SendRoundMsgToAll(room, &msg.ReqRound{
		Round:       int32(room.Round),
		RoundSitPos: int32(sitPos),
		PlayerOpt:   &msg.PlayerOpt{OptType: msg.PlayerOptType_OPT_FOLD},
		UserId:      room.GetPlayerBySitPos(sitPos).GetUserId(),
	})
}

// 跟注
func call(room *room.Room, sitPos int) {
	SendRoundMsgToAll(room, &msg.ReqRound{
		Round:       int32(room.Round),
		RoundSitPos: int32(sitPos),
		PlayerOpt:   &msg.PlayerOpt{OptType: msg.PlayerOptType_OPT_CALL},
		UserId:      room.GetPlayerBySitPos(sitPos).GetUserId(),
	})
}

// 加注
func raise(room *room.Room, sitPos int) {
	SendRoundMsgToAll(room, &msg.ReqRound{
		Round:       int32(room.Round),
		RoundSitPos: int32(sitPos),
		PlayerOpt:   &msg.PlayerOpt{OptType: msg.PlayerOptType_OPT_RAISE},
		UserId:      room.GetPlayerBySitPos(sitPos).GetUserId(),
	})
}

// 加倍
func double(room *room.Room, sitPos int) {
	SendRoundMsgToAll(room, &msg.ReqRound{
		Round:       int32(room.Round),
		RoundSitPos: int32(sitPos),
		PlayerOpt:   &msg.PlayerOpt{OptType: msg.PlayerOptType_OPT_DOUBLE},
		UserId:      room.GetPlayerBySitPos(sitPos).GetUserId(),
	})
}

// 放弃
func fold(room *room.Room, sitPos int) {
	SendRoundMsgToAll(room, &msg.ReqRound{
		Round:       int32(room.Round),
		RoundSitPos: int32(sitPos),
		PlayerOpt:   &msg.PlayerOpt{OptType: msg.PlayerOptType_OPT_FOLD},
		UserId:      room.GetPlayerBySitPos(sitPos).GetUserId(),
	})
}

// 取消操作超时
func cancelOptTimeout(player *room.Player, sitPos int) {
	eventID := fmt.Sprintf("player_%s_opt_%s", player.Id, sitPos)
	timerMgr.RemoveEvent(eventID)
}
